#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 in_position;
layout(location = 1) in vec3 in_normal;
layout(location = 2) in vec2 in_uv;

layout(location = 0) out vec3 position_world;
layout(location = 1) out vec3 normal_world;
layout(location = 2) out vec2 uv;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform bool isTess;


void main() {
	normal_world = normalMatrix * in_normal;

	normal_world = normalize(normal_world);

	uv = in_uv;
	vec4 position_world_ = modelMatrix * vec4(in_position, 1.0f);

	//ezek mennek a tess-be
	position_world = position_world_.xyz;
	if(isTess)
	{
		gl_Position = position_world_;
	} else
	{
		gl_Position = viewProjMatrix * position_world_;
	}

}
